	IMPLICIT INTEGER*4 (A-Z)
	INTEGER*2 REQCHN,CRFCHN,PACKET(15),IERR,QIOSB(4),I
	BYTE CHNDES(80)
	INCLUDE 'SYS$LIBRARY:SIGDEF'
C
C
	PARAMETER	SS$SUPERSEDE = '0631'X	!MAILBOX NAME SUPERSEDED
	PARAMETER IO$_READVBLK = '0031'X	!READ A LOGICAL BLOCK
	PARAMETER IO$_WRITEVBLK = '0030'X	!WRITE A VIRTUAL BLOCK
	PARAMETER IO$M_NOW = '0040'X		!DON'T WAIT FOR MAILBOX READ
C
C	OPEN THE ERROR FILE
C
	ERRCNT = '80000000'X
	UIC = (8*65536)+32
	OPEN(UNIT=4,NAME='DBA0:[SYSMGR]CRFERR.LOG',
	1TYPE='NEW',DISP='PRINT')
C
C	CREATE MY MAILBOX IF THE MAIL BOX RCVDCRF... DOES NOT YET EXIST.
C
	RC = 0
	RC = SYS$ASSIGN('RCVDCRF...',REQCHN,,)
	IF (RC.EQ.SS$_NORMAL) GOTO 50
	RC = SYS$CREMBX(%VAL(1),REQCHN,%VAL(30),%VAL(1200),,,'RCVDCRF...')
	IF ((RC.NE.SS$_NORMAL).AND.(RC.NE.SS$SUPERSEDE)) GOTO 4
C
C	CREATE MY DETACHED PROCESS
C
50	RC = SYS$CREPRC(CRFID,'DBA0:[SYSEXE]CREF.EXE',,,
	1'DBA0:[SYSMGR]CRFERR.LOG',,,'CROSSR',%VAL(4),%VAL(UIC),,)
	IF (RC.NE.SS$_NORMAL) GOTO 5
	INIFLG = 0
C	OPEN(UNIT=1,NAME='RCVDCRF...',TYPE='OLD')
C
C	HERE WE START OUR ENDLESS PROCESSING LOOP
C
100	CALL SYS$QIOW(,%VAL(REQCHN),%VAL(IO$_READVBLK),QIOSB,,,PACKET,
	1 %VAL(30),,,,)
C	READ (1,9999,ERR=8) (PACKET(I),I=1,15)
9999	FORMAT(A2)
C
C	IT WILL CONTINUE HERE WHEN THE MAILBOX IS WRITTEN TO BY MAC OR TKB
C	  BECAUSE OF THE SYNCHRONOUS NATURE OF MAILBOXES.
C
	IF (INIFLG.NE.0) GOTO 110
C
C	WE WAIT UNTIL WE GET SOMETHING BEFORE WE ASSIGN TO THE 'REAL' CROSS-
C	  REFERENCE PROGRAM'S MAILBOX
C
	RC = SYS$ASSIGN('RCVDCROSSR',CRFCHN,,)
	IF (RC.NE.SS$_NORMAL) GOTO 100
	INIFLG = 1
C
C	NOW WRITE THE CREF MAILBOX
C
110	CALL SYS$QIO(,%VAL(CRFCHN),%VAL(IO$_WRITEVBLK.OR.IO$M_NOW),QIOSB,,,
	1 PACKET,%VAL(30),,,,)
	CALL SYS$WAKE(,'CROSSR')
	GOTO 100
C
C	MAILBOX CREATION ERROR
C
4	WRITE(4,9998)RC
9998	FORMAT(//,X,'ERROR IN CREATION OF MAILBOX. ERROR CODE: ',Z9)
	GOTO 13
C
C	PROCESS CREATION ERROR
C
5	WRITE(4,9997)RC
9997	FORMAT(//,X,'ERROR IN CREATION OF CREF PROCESS. ERROR CODE: ',Z9)
	GOTO 13
C
C	OPEN ERROR FOR CREF MAILBOX
C
6	CALL ERRSNS(IERR)
	WRITE(4,9996)IERR
9996	FORMAT(//,X,'ERROR IN OPENING CREF MAILBOX. ERROR CODE = ',I6)
	GOTO 13
C
C	OPEN ERROR FOR MY MAILBOX
C
7	CALL ERRSNS(IERR)
	WRITE(4,9995)IERR
9995	FORMAT(//,X,'ERROR IN OPENING MY MAILBOX. ERROR CODE: ',I6)
	GOTO 13
C
C	READ ERROR FOR MY MAILBOX
C
8	CALL ERRSNS(IERR)
	WRITE(4,9994)IERR
9994	FORMAT(//,X,'ERROR IN READING MY MAIL. I/O ERROR CODE: ',I6)
	GOTO 13
C
C	READ ERROR FOR THE CREF MAILBOX
C
9	CALL ERRSNS(IERR)
	WRITE(4,9993)IERR
9993	FORMAT(//,X,'ERROR IN WRITING TO CREF. I/O ERROR CODE: ',I6)
C
C	ERROR IS GETTING A CHANNEL FOR THE MAILBOX
C
10	WRITE(4,9992)RC
9992	FORMAT(//,X,'ERROR IN ASSIGNING CHANNEL TO CREF MAILBOX.',
	1' ERROR CODE: ',Z9)
C
C	ERROR IN GETTING CHANNEL INFO FOR MY MAILBOX
11	WRITE(4,9991)RC
9991	FORMAT(//,X,'ERROR IN GETTING CHANNEL INFO FOR MY MAILBOX.',
	1' ERROR CODE: ',Z9)
	GOTO 13
C
C	ERROR IN INSERTING A NAME IN THE SYSTEM SYMBOL TABLE
12	WRITE(4,9990)RC
9990	FORMAT(//,X,'ERROR IN INSERTING A NAME IN THE SYSTEM SYSTEM ',
	1'TABLE. ERROR CODE: ',Z9)
C
C	ERROR EXIT
C
13	CALL EXIT
	END
