	program fdir
C
CPROGRAM WRITTEN BY ERIC YOUNGDALE
C		CARLETON COLLEGE
C		NORTHFIELD, MINNESOTA  55057
C
C THIS PROGRAM WILL MAKE A LIST OF ALL OF THE DIRECTORIES AND SUBDIRECTORIES
C ON A GIVEN DEVICE. FOR THE WHOLE SYSTEM, ONE CAN CALL FDIR REPEATEDLY
C FDIR WILL CHECK TO SEE IF A FILE WITH A .DIR EXENSION IS REALLY A DIR BY
C CHECKING THE BIT IN THE INDEX FILE.  ONLY FILES WITH A .DIR EXENSION WILL
C BE CHECKED FOR DIRECTORY CHARACTERISTICS.  THIS COULD BE EASILY CHANGED
C TO ALLOW ONE TO CHECK FOR RENAMED DIRECTORIES.
C
C THIS PROGRAM IS THE 'MOTHER' OF QUOT, USED FOR DISK QUOTA CHECKING.
C
C DIR_LIST IS DIMENSIONED FOR THE MAXIMUM NUMBER OF DIRECTORIES WE CAN HAVE.
C ADMITTEDLY THIS IS A PIG ON MEMORY, BUT THE NEXT REV WILL USE DYNAMIC
C STRING ALLOCATION TO BE MORE EFFICIENT,
	character*512 CIOLIST,CLIST
	CHARACTER*128 DIR_LIST(2048),ROOT,dname,TEMP,START,outfile,CRE_DIR_FILE
	CHARACTER*7 CUIC
	character*4 DEV_NAME
	CHARACTER*3 JUNK
	CHARACTER*1 LEN
	BYTE BLEN,BLEN1,BID(2),BID1(2)
	LOGICAL*1 DFLAG(2048),DTEMP,REAL_DIR,CREDIR
	INTEGER*4 DIR_COUNT,DIR_POINT,ZRLOC,ROOTL,DELTA,ID,STATUS
	INTEGER*2 UIC
	EQUIVALENCE (LEN,BLEN),(CIOLIST,BID),(ID,BID1)
	COMMON /OWNER_UIC/ UIC(2)
	CREDIR=.FALSE.
	call get_dcl(ichar,start,status)
	if(status.ne.1) goto 1
2000	if(start(1:1).eq.' ') then
	start=start(2:128)
	goto 2000
	endif
	dev_name=start
	i=index(start,' ' )
	start=start(i:128)
	IF(START.EQ.' ') GOTO 1
2001	if(start(1:1).eq.' ') then
	start=start(2:128)
	goto 2001
	endif
	i=index(start,' ')
	outfile=start(i+1:128)
	start=start(1:i-1)
	I=INDEX(OUTFILE,' ')
	CRE_DIR_FILE=OUTFILE(I+1:128)
	OUTFILE=OUTFILE(1:I-1)
	GOTO 2
1	type 1001,'Enter the device name: '
	accept 1000,dev_name
	TYPE 1001,'Enter the directory to start in: '
	accept 1000,start
	TYPE 1001,'ENTER THE OUTPUT FILE NAME FOR DIRECTORY LIST: '
	ACCEPT 1000,OUTFILE
	TYPE 1001,'ENTER THE OUTPUT FILE NAME FOR THE CREDIR COMMAND FILE: '
	ACCEPT 1000,CRE_DIR_FILE
1000	format(a)
1001	format(x,a,$)
2	DO 3 I=1,2048
3	DFLAG(I)=.FALSE.
	IF(CRE_DIR_FILE.NE.' ') CREDIR=.TRUE.
	IF(CREDIR.EQ..TRUE.) OPEN(UNIT=3,NAME=CRE_DIR_FILE,
	1CARRIAGECONTROL='LIST')
	dir_count=0
	dir_point=1
	root=dev_name
	root(5:13)=':[000000.'
	rootl=index(root,' ')
	dir_list(1)=root
	IF(INDEX(START,'[').NE.0) START=START(INDEX(START,'[')+1:128)
	IF(INDEX(START,']').NE.0) START=START(1:INDEX(START,']')-1)
	if(start.eq.'000000') then
	dir_list(1)(14:128)=start
	else
	root(rootl:128)=start
	rootl=index(root,' ')+1
	dir_list(1)=root
	root(rootl-1:rootl-1)='.'
	dir_count=1
	endif
5	dname=dir_list(dir_point)
	i=1
C START OF DIRECTORY LOOP, ONCE THROUGH FOR EACH DIRECTORY FILE CHECKED.
6	itmp=index(dname(i+1:128),'.')+i
	if(itmp.ne.i) then
	i=itmp
	goto 6
	endif
	dname(i:i)=']'
	i=index(dname,' ')
	dname(i:128)='.dir'
C WE HAVE FORMATTED A DIR NAME, NOW TRY TO OPEN UP THE FILE.
	open(unit=1,name=dname,type='old',recordtype='variable'
	1,readonly,shared,ERR=15)
C NOW READ A FILE NAME OUT OF THE FILE
10	read(1,1300,ERR=20) JUNK,LEN,CIOLIST
1300	FORMAT(A3,A1,A50)
	CLIST=CIOLIST(1:BLEN)
C NOT A DIR FILE, DO NOT ADD TO LIST OF FILES.
	IF (CLIST(BLEN-2:BLEN).NE.'DIR') GOTO 10
C GET INDEX FILE NUMBER FOR CHECK TO SEE IF REAL DIR
	BLEN1=BLEN
	IF ((BLEN.AND.1).EQ.1) BLEN1=BLEN1+1
	CIOLIST=CIOLIST(BLEN1+3:512)
	BID1(2)=BID(2)
	BID1(1)=BID(1)
	CALL VERIFY(DEV_NAME,ID,REAL_DIR)
	IF (REAL_DIR.EQ..FALSE.) GOTO 10
C THIS IS A REAL DIRECTORY, ADD TO LIST
	dir_count=dir_count+1
	DFLAG(DIR_POINT)=.TRUE.
	dir_list(dir_count)=root
	dir_list(dir_count)(rootl:128)=clist(1:blen-4)
C SEE IF THE USER WANTS A LIST OF DIRECTORIES WITH UIC'S
	IF(CREDIR.EQ..FALSE.) GOTO 10
	CLIST=DIR_LIST(DIR_COUNT)
	CLIST(ROOTL+BLEN-4:ROOTL+BLEN-4)=']'
	I=INDEX(CLIST,'000000.')
	IF(I.NE.0) THEN
	CLIST(I:128)=CLIST(I+7:128)
	BLEN=BLEN-7
	ENDIF
	ENCODE(7,1011,CUIC) UIC(2),UIC(1)
	DO 12 I=1,7
12	IF(CUIC(I:I).EQ.' ') CUIC(I:I)='0'
	WRITE(3,1010) CUIC,CLIST(1:ROOTL+BLEN-4)
	GOTO 10
C
C THIS ROUTINE ONLY ENTERED IF THERE IS AN ERROR ON OPENING THE FILE
C
15	TYPE *,'%FDIR-W-ERROPFILE, ERROR OPENING DIR FILE ',DNAME(1:I+3)
	DO 21 I=DIR_POINT,DIR_COUNT-1
	DFLAG(I)=DFLAG(I+1)
21	DIR_LIST(I)=DIR_LIST(I+1)
	IF(DIR_POINT.EQ.1) THEN
C THE CRETIN GAVE A BAD ROOT DIR NAME
	TYPE *,'%FDIR-F-ERRROOT, BAD ROOT FILE'
	IF(CREDIR.EQ..TRUE.) CLOSE(UNIT=3)
	CALL EXIT(1)
	ENDIF
	DIR_COUNT=DIR_COUNT-1
	GOTO 22
C
C WE HAVE CHECKED EVERYTHING IN THIS DIR FILE, ON TO THE NEXT ONE.
20	CLOSE (UNIT=1,ERR=25)
	DIR_POINT=DIR_POINT+1
22	ROOT=DIR_LIST(DIR_POINT)
	ROOTL=INDEX(ROOT,' ')+1
	ROOT(ROOTL-1:ROOTL-1)='.'
C THERE ARE NO MORE DIRECTORIES, NOW LETS MAKE A LIST.
	IF(DIR_POINT.LE.DIR_COUNT) GOTO 5
25	CLOSE(UNIT=2)
	IF(CREDIR.EQ..TRUE.) CLOSE(UNIT=3)
C
C NOW STRIP OFF THE [000000. IF IT IS THE DIRECTORY NAME, AND PUT ON A ]
C AT THE END.
C
	ZRLOC=INDEX(DIR_LIST(1),'000000.')
	DO 30 I=1,DIR_COUNT
	DIR_LIST(I)(ZRLOC:128)=DIR_LIST(I)(ZRLOC+7:128)
	I1=INDEX(DIR_LIST(I),' ')
30	DIR_LIST(I)(I1:I1)=']'
C
C NOW SORT THE DIRECTORY NAMES SUCH THAT THE SUBDIRECTORIES COME
C AFTER THEIR SUPERIOR DIRECTORY.
C
	DO 50 I=1,DIR_COUNT
C DFLAG IS A FLAG THAT INDICATES THAT THIS DIR HAS SUBDIRS.
	IF(DFLAG(I).EQ..FALSE.) GOTO 50
	DELTA=1
	I1=INDEX(DIR_LIST(I),' ')-2
	DO 50 J=I+1,DIR_COUNT
45	IF ((DIR_LIST(J)(1:I1).NE.DIR_LIST(I)(1:I1)).OR.
	1(DIR_LIST(J)(I1+1:I1+1).NE.'.')) GOTO 50
	TEMP=DIR_LIST(J)
	DTEMP=DFLAG(J)
	DO 49 J1=J,I+DELTA+1,-1
	DFLAG(J1)=DFLAG(J1-1)
49	DIR_LIST(J1)=DIR_LIST(J1-1)
	DFLAG(I+DELTA)=DTEMP
	DIR_LIST(I+DELTA)=TEMP
	DELTA=DELTA+1
50	CONTINUE
C NOW WE HAVE SORTED, PRINT LIST
	OPEN(UNIT=1,NAME=OUTFILE,CARRIAGECONTROL='LIST')
	DO 51 I=1,DIR_COUNT
51	WRITE (1,1005),DIR_LIST(I)(1:INDEX(DIR_LIST(I),' '))
1005	FORMAT(A)
1010	FORMAT('$CR/D/O=[',A7,'] ',100A)
1011	FORMAT(O3,',',O3)
	end



	SUBROUTINE VERIFY(DEV,REC,RESULT)
C THIS SUBROUTINE VERIFIES THAT A FILE WITH .DIR EXTENSION IS REALLY
C A DIRECTORY, AND NOT JUST ANOTHER FILE.
C IT ALSO RETURNS THE FILES UIC FOR THE CREATION FILE.
C
C THIS ROUTINE AUTOMATICALLY INITIALIZES ITSELF, AND TAKES INTO ACCOUNT THE
C CLUSTERSIZE OF THE DISK WHEN LOOKING UP INDEXES
	IMPLICIT INTEGER(A-Z)
	COMMON /OWNER_UIC/ UIC(2)
	INTEGER*2 UIC
	LOGICAL*1 RESULT
	INTEGER*2 INDEX(256)
	CHARACTER DEV*4,NAME*40
	DATA OFFSET/0/
C OFFSET IS CLUSTER*4+S(SIZE OF INDEX BIT MAP)
C (DO NOT ADD ONE, FORT REC STARTS WITH ONE, NOT ZERO)
	RESULT=.FALSE.
	IF(OFFSET.NE.0) GOTO 10
	NAME=DEV
	NAME(5:40)=':[0,0]INDEXF.SYS'
	OPEN(UNIT=2,NAME=NAME,READONLY,SHARED,TYPE='OLD'
	1,ACCESS='DIRECT',RECORDSIZE=128,FORM='UNFORMATTED')
	READ(2'2) INDEX
	C=INDEX(8)
	S=INDEX(17)
	OFFSET=C*4+S
10	READ(2'REC+OFFSET,ERR=20) INDEX
	IF(INDEX(27).EQ."20200) RESULT=.TRUE.
	UIC(1)=INDEX(31)
	UIC(2)=INDEX(32)
20	RETURN
	END
