$ VFL := 'F$VER()
$ SET NOVERIFY
$!
$!
$!	BUILD FILEINFO.FOR .....			5-DEC-1979
$!					VICKI WOOLF
$!					PROGRAM OF COMPUTER GRAPHICS
$!					120 RAND HALL
$!					CORNELL UNIVERSITY
$!					ITHACA,  NEW YORK  14853
$!					(607) 256-7444
$!
$ TYPE SYS$INPUT

	BUILD FILEINFO.FOR	- FILEINFO displays the contents of the
				  map pointers of a given file.

				  NOTE: This software was written using
				  the native mode FORTRAN compiler.
				  If you are running under 1.5, just
				  ignore the compilation warning messages.
				  When you receive your compiler update
				  these messages will go away. 

$!
$!
$ type sys$input

	***************************************************************

	This build procedure assumes that the following files are in
	the default directory.

	FILEINFO.FOR
	FILEINFO.MAR

$ !	Set up noverify, error and abort branches
$
$ ON ERROR THEN GOTO ERROR_BRANCH
$ ON WARNING THEN GOTO ERROR_BRANCH
$ ON SEVERE_ERROR THEN GOTO ERROR_BRANCH
$ ON CONTROL_Y THEN GOTO ABORT_BRANCH
$
$
$ !	Compile module  allowing "D" for debugging
$
$ DEBUG := FALSE
$ IF P1 .EQS. "D" THEN DEBUG := TRUE
$
$ WRITE  SYS$OUTPUT  "Compiling and assembling..."
$ IF DEBUG THEN FORTRAN/CONT=99/DEBUG/NOOPT/CHECK=ALL/D_LINES FILEINFO
$ IF .NOT. DEBUG THEN FORTRAN/CONT=99/NODEBUG/OPTIMIZE/NOCHECK/NOD_LINES -
	FILEINFO
$ IF DEBUG THEN MAC/ENABL=(DBG)/OBJECT=FILEINFOM.OBJ FILEINFO
$ IF .NOT. DEBUG THEN MAC/OBJECT=FILEINFOM.OBJ FILEINFO
$
$ WRITE  SYS$OUTPUT "Linking program..."
$ IF DEBUG THEN  LINK/DEBUG FILEINFO,FILEINFOM
$ IF .NOT. DEBUG THEN LINK FILEINFO,FILEINFOM
$
$ WRITE  SYS$OUTPUT  "--- FILEINFO built."
$ DELETE FILEINFO.OBJ;*,FILEINFOM.OBJ;*
$ IF 'VFL THEN SET VERIFY
$!
$ FILEINFO :== $'F$LOG("SYS$DISK")''F$DIR()'FILEINFO
$!
$ TYPE SYS$INPUT

The symbol FILEINFO has been defined. Include this definition in your
default LOGIN.COM file.
$SHO SYM FILEINFO
$TYPE SYS$INPUT


Following is an example:
$!
$ SET VERIFY
$ FILEINFO FILEINFO.COM
$ IF 'VFL THEN SET NOVERIFY
$ EXIT
$
$
$ !	On error or abort, type error message and delete object modules
$
$ ERROR_BRANCH:
$ WRITE  SYS$OUTPUT  "--- Errors stop program build."
$ DELETE FILEINFO.OBJ;*,FILEINFOM.OBJ;*
$ IF .NOT.'VFL THEN SET VERIFY
$ EXIT %X2C
$
$ ABORT_BRANCH:
$ WRITE  SYS$OUTPUT  "--- ^Y terminates program build."
$ DELETE FILEINFO.OBJ;*,FILEINFOM.OBJ;*
$ IF .NOT.'VFL THEN SET VERIFY
$ EXIT %X614
