c	anon  - send anonymous messages to someone.
c	written by Jim Reno, MIT Joint Computer Facility
	integer*4 sys$brdcst,conv,users,fstack,curfile
	character*400 line
	character*245 out
	character*5 term,list(100)
	character*2 temp
	character*80 prefix,postfix
	logical preformat,sendlist(100)
	character*63 files(20)
	common /file/ files
	common /stack/ curfile,fstack(100)
	do 1 i=1,20
1	files(i)=' '
	curfile=0
	open(unit=1,name='ANONCOM',err=1000,type='old')
	curfile=1
	files(1)='ANONCOM'
	fstack(1)=1
1000	continue
	prefix=' '
	postfix=' '
	preformat=.false.
	users=0
	if(curfile.eq.0.or.fstack(curfile).eq.0) then
		type 5
5		format(' Anon.')
		type 10,'Device: '
10		format (' ',a,$)
		accept 20,term
20		format(a)
		call valiterm(term)
		list(1)=term
		sendlist(1)=.true.
		users=1
		endif
25	continue
	call getlin(line,preformat,inputlu)
	out=' '
	if(line.eq. 'e') goto 30
	if(line.eq. ' ') goto 25
	ipoint=1
	call special(line,ipoint,preformat,
	1  sendlist,users,list,prefix,postfix)
	line=line(ipoint:400)
	ipoint=1
	lpre=lenstr(prefix,80)
	llin=lenstr(line,400)
	lpost=lenstr(postfix,80)
	if(llin.eq.0) go to 25
	if(lpre.ne.0) line= prefix(1:lpre) //
	1	line(1:llin) // postfix
	if(lpre.eq.0) line=line(1:llin) // postfix
	jpoint=0
27	jpoint=jpoint+1
	if (line(ipoint:ipoint).eq.'/') then
		ipoint=ipoint+1
		if(line(ipoint:ipoint).eq.'/') then
			out(jpoint:jpoint)='/'
		else
			out(jpoint:jpoint)=char(conv(
	1 		 line(ipoint:ipoint+9),ipoint))
		endif
	else
		out(jpoint:jpoint)=line(ipoint:ipoint)
	endif
	ipoint=ipoint+1
	if(jpoint.le.245) goto 27
	
	do 190 ii=245,1,-1
	kk=ii
	if(out(ii:ii).ne.' ') goto 195
190	continue
	goto 25
195	continue

	if(preformat) then
		type 200,out(1:kk)
200		format(' ',a,/,' Would be sent to:')
		do 201 i=1,users
201		if(sendlist(i)) type 202,list(i)
202		format('       ',a5)
		type 10,'Send(y or n)? '
		accept 20,temp
		if(temp(1:1).ne.'y'.and.temp(1:1).ne.'Y') goto 25
		endif

	do 300 i=1,users
	if(.not.sendlist(i))go to 300
	term=list(i)
	if(term.ne.'ALL') then
		ii=sys$brdcst(out(1:kk),term)
		if(ii.ne.1) type *,'Can''t send to ',term
	else
		ii=sys$brdcst(out(1:kk),)
		if(ii.ne.1) type *,'Can''t send to all.'
	endif
300	continue
	goto 25
30	continue
	end


	integer function lenstr(str,len)
	character*(*) str
	integer len
	i=0
	do 100 j=len,1,-1
	if(str(j:j).ne.' ') goto 110
100	continue
	lenstr=0
	return
110	lenstr=j
	return
	end
	
	integer function conv(str,i)
	implicit integer*4(a-z)
	character*1 str(0:9)
	logical hexflag
C	take care of special instances
	if(str(0).eq.'b') then
		i=i+1
		conv=7
		return
	endif
C	now find length of field

	hexflag=.false.
	do 100 k=0,10
	if(k.eq.0) then
		if(str(k).eq.'x') then
		hexflag=.true.
		go to 100
		endif
	endif
	len=k
	if(hexflag.and.(str(k).ge.'a'.and.str(k).le.'f')) go to 100
	if(str(k).lt.'0'.or.str(k).gt.'9') go to 105
100	continue
102	conv=ichar('/')
	return
105	if(len.eq.0) go to 102
	i=i+len-1
	if(str(len).eq.'/') i=i+1
	
	if(str(0).eq.'0') then
		if(len.eq.1) then
			conv=0
			return
		else
			radix=8
			start=1
		endif
	else if(str(0).eq.'x') then
		radix=16
		start=1
	else
		radix=10
		start=0
	endif
	val=0
	do 200 k=start,len-1
	val=val*radix
	if(str(k).eq.'a') then 
		val=val+10
	else if(str(k).eq.'b') then
		val=val+11
	else if(str(k).eq.'c') then
		val=val+12
	else if(str(k).eq.'d') then
		val=val+13
	else if(str(k).eq.'e') then
		val=val+14
	else if(str(k).eq.'f') then
		val=val+15
	else
		val=val+ichar(str(k))-48
	endif
200	continue
	conv=val
	return
	end


	subroutine valiterm(term)
	character*5 term
	character*2 temp
	integer fstack(100),curfile
	common /stack/curfile,fstack
	do 21 i=1,5
	n=ichar(term(i:i))
	if(n.ge.97.and.n.le.122) n=n-32
21	term(i:i)=char(n)
	if(term.eq.'ALL') goto 25
	i=1
	if(term(1:1).eq.'_') goto 25
	if(term(1:2).eq.'TT'.or. term(1:2).eq.'OP') i=3
	temp=term(i:i+1)
	term(4:5)=temp
	if(term(1:2).ne.'OP')then
		term(1:3)='_TT'
	else
		term(1:3)='_OP'
	endif
25	if(curfile.eq.0.or.fstack(curfile).eq.0)
	1 type *,'Sending anonymously to device ',term
	return
	end

	subroutine special(line,ip,preformat,sendlist,
	1	users,list,prefix,postfix)
	character*80 line,prefix,postfix
	logical preformat,sendlist(100),zeroed
	integer users,ip,curfile,conv,fstack
	character*5 list(100),term
	character*63 files(20)
	common /file/ files
	common /stack/ curfile,fstack(100)

	zeroed=.false.
C	basic loop is done once for each command sequence.
C	command sequence is \<comm> or:
C		\u	show user list
C		\p	Change to/from preformat mode
C		\a.tt.	Add user
C		\d#	Delete user
C		\#	Toggle user # from T to F to T...
C		\i..id.	Set prefix
C		\e...	Set postfix (ending chars)
C		\o#name Open file NAME with unit #
C		\r#	continue reading from file #
C		\c#	close file #
C		\f#name Open file and start reading
C		\h	Halt; pauses reading from file
C		\lf	list open files
C		\ls	list stack
C	commands may be repeated i.e. \a\d\a\p\#\#\# but first must be
C	in col one.
10	if(line(ip:ip).ne.'\') return
	ip=ip+1
	if(line(ip:ip).eq.'a') then	! add user
		term=line(ip+1:ip+5)
		call valiterm(term)
		users=users+1
		list(users)=term
		sendlist(users)=.true.
		ip=ip+6
	else if(line(ip:ip).eq.'r') then
		ip=ip+1
		i=conv(line(ip:ip+9),ip)
		if(i.eq.0) then
			curfile=curfile+1
			fstack(curfile)=0
		else if(files(i).ne.' ') then
			curfile=curfile+1 ! Push down stack once
			fstack(curfile)=i ! Put file lu on stack.
		else
			type *,'File',i,' not open.'
			line=' '
			ip=1
		endif
	else if(line(ip:ip).eq.'c') then	! close file.
		ip=ip+1
		i=conv(line(ip:ip+9),ip)
		if (files(i).ne.' ') close (unit=i)
		files(i)=' '
		if(curfile.gt.0.and.fstack(curfile).eq.i) curfile=curfile-1
	else if(line(ip:ip).eq.'o') then	!open file
		ip=ip+1	
		i=conv(line(ip:ip+9),ip)
		ip=ip+1
		if (files(i).ne.' ') close(unit=i)	!close old file
		open(type='old',unit=i,name=line(ip:ip+62),err=1000)
		files(i)=line(ip:ip+62)
		goto 1001
1000		type *,'Open: Cannot open file ',line(ip:ip+62)
		files(i)=' '
		if(curfile.gt.0.and.fstack(curfile).eq.i) curfile=curfile-1
1001		line=' '
		ip=1
	else if(line(ip:ip).eq.'f') then	! open file & start reading			
		ip=ip+1
		i=conv(line(ip:ip+9),ip)
		ip=ip+1
		if (files(i).ne.' ') close(unit=i)
		open(type='old',unit=i,name=line(ip:ip+62),err=2000)
		files(i)=line(ip:ip+62)	
		curfile=curfile+1
		fstack(curfile)=i
		goto 2001
2000		type *,'File: Cannot open file ',line(ip:ip+62)
		files(i)=' '
		if(curfile.gt.0.and.fstack(curfile).eq.i) curfile=curfile-1
2001		line=' '
		ip=1 	
	else if(line(ip:ip).eq.'h') then	! halt read on current file.
		curfile=curfile-1
		if(curfile.lt.0) curfile=0
	else if(line(ip:ip).eq.'i') then	!set prefix
		prefix=line(ip+1:ip+80)
		line=' '
		ip=1
	else if(line(ip:ip).eq.'e') then	!set postfix
		postfix=line(ip+1:ip+80)
		line=' '
		ip=1
	else if (line(ip:ip).eq.'d') then	!delete user
		ip=ip+1
		i=conv(line(ip:ip+9),ip)
		users=users-1
		if (users.ge.i) then	! pack user lists
			do 30 k=i,users
			list(k)=list(k+1)
30			sendlist(k)=sendlist(k+1)
		endif
	else if (line(ip:ip).eq.'u') then	!list users	
		type *,' List of users: '
		do 40 i=1,users
40		type 50,i,list(i),sendlist(i)
50		format('  User number ',i2,' device ',a5,' is ',l1)
	else if(line(ip:ip).eq.'p') then
		preformat=.not.preformat
	else if(line(ip:ip).eq.'l') then	! List stack or files.
		ip=ip+1
		if(line(ip:ip).eq.'s') then
			if(curfile.gt.0) then
				type *,'Current file stack:'
				do 75 i=1,curfile
				if (fstack(i).ne.0) then
					type 80,i,fstack(i),files(fstack(i))
				else
				type 81,i,'--Terminal--'
81		format(' ',i2,' (you) ',' file: ',a)
				endif
80		format(' ',i2,' lu: ',i2,' file: ',a)
75				continue
			else
				type *,' No file stack(at terminal).'
				endif
		else if(line(ip:ip).eq.'f') then	!files.
			nfiles=0
			do 90 i=1,20
90			if (files(i).ne.' ') nfiles=nfiles+1
			if (nfiles.eq.0) then
				type *,' No open files.'
			else
				type *,' List of open files:'
				do 100 i=1,20
				if(files(i).ne.' ') type 95,i,files(i)
100				continue
95		format(' Logical unit ',i2,' File: ',a)
				endif
			endif
		ip=ip+1
	else if(line(ip:ip).le.'0'.or.line(ip:ip).ge.'9') then
		type *,' Erroneous command, line ignored.'
		line=' '
		ip=1
	else	!numeric 
		num=ichar(line(ip:ip))-48
		ip=ip+1
		if(line(ip:ip).ge.'0'.and.line(ip:ip).le.'9') then
			num=num*10+ichar(line(ip:ip))-48
			ip=ip+1
			endif
		if(num.gt.users) then
			type *,num,' too big. Line ignored'
			line=' '
			ip=1
		else 
			sendlist(num)=.not.sendlist(num)
		ip=ip-1
		endif
	endif
	ip=ip+1
	goto 10
	end

	subroutine getlin(line,preformat)
	character*400 line
	logical preformat
	character*80 in
	character*63 files(20)
	integer fstack,curfile
	common /file/ files
	common /stack/ curfile,fstack(100)
	line=' '
	ip=1
5	if(curfile.eq.0.or.fstack(curfile).eq.0) then
		if (ip.eq.1) then
			if (preformat) then
				type 10,'P:'
			else
				type 10,':'
			endif
		else if (preformat) then
			type 10,'P:_'
		else 
			type 10,':_'
		endif
	
10		format(' ',a,$)
		accept 20,in
20		format(a80)
	else
		read(fstack(curfile),20,end=1000) in
	endif
	do 30 i=80,1,-1
	len=i
	if(in(i:i).ne.' ') go to 40
30	continue
	return	! input line is of zero lenght - return.
40	line(ip:400)=in(1:len)
	ip=ip+len
	if(in(len:len).eq.'-') then
		ip=ip-1
		go to 5		!continuation line - do it again
	else if (len.eq.80) then
		go to 5
	else
		return
	endif
200	line='e'
	return
1000	close(unit=fstack(curfile))
	files(fstack(curfile))=' '
	curfile=curfile-1
	if(curfile.lt.0) curfile=0
	goto 5
	end
